
!********************************************
! module OmdetectPhotometryDefs_mod
! For use with module omdetectAperturePhotometry
!
!********************************************
module OmPhotometryDefs_mod
    use dal

    type OMpoint
        real(single) :: x
        real(single) :: y
        integer(int8) :: extension
    end type OMPOINT


    integer(int16) :: sourceNumber    ! The number of the source 

    integer :: noPointSources  

    !***********************************************************
    ! Array CCDImage will store the 2-d background image
    !***********************************************************

    integer(int16) :: nx, ny
    real(single), dimension(: , :), pointer :: CCDImage => null()
   

    ! Smoothed image to be used to get the background
    real(single), dimension(: , :), pointer :: backGroundImage => null()


    integer(int16), dimension(:, :), pointer :: sourceNumImage => null()

  
    logical(bool), dimension(: , :), pointer :: qualityImage => null()



    integer(int32), dimension(:), pointer :: sortIndex => null()
    type(OMPOINT), dimension(:), pointer :: sourceCoords => null()
 
    !***********************************************************
    ! The following will start the array dimensions of the images
    !***********************************************************
    integer(int32) :: il = 0  ! The start x index
    integer(int32) :: jl = 0  ! The start y index
    integer(int32) :: iu      ! The finish x index
    integer(int32) :: ju      ! The finish y index
    real(single) :: xLeft
    real(single):: yBottom
    real(single):: xRight
    real(single):: yTop

    real(single) :: apertureRadius
    real(single)  :: coincLossRadius     

    real(double)  :: apertureArea   ! The actual aperture area used to get counts
    real(single)  :: fullApertureArea   ! The required aperture area used to get counts
    
 

   
    !************************************************************************
    ! The following will store the maximum of the x amd y fwhm of each object
    !*************************************************************************
    real (single), dimension(:), pointer :: objectWidth => null()
 
   
 
    !************************************************************************
    ! The following are used to compute the median background around a source
    !************************************************************************

    real (single), dimension(:), pointer :: backgroundPixel => null()
   

    real(double) :: backgroundCountsMode
    real(double) :: backgroundCountsModeError
    
    real (single) :: minimumApertureRadius    ! The minimum allowd aperture radius for doing photometry

    real (single) :: innerRadius              ! The inner radius for the background counts
  
   
    real (single) :: outerRadius              ! The outer radius for the background counts
    real (single) :: imageMode                ! The background mode value 
    integer(int32) :: maxNumPixels



    real(double) :: frameTime                 ! The frame time in seconds
    
    real(double) :: deadFrac

    real(single) :: exposureLength

 

end module OmPhotometryDefs_mod












